#define GRIDSIZE 9
#define rows 3
#define columns 3
#include<cstdio>
#include<iostream>
#include<cstdlib>
#include<cassert>
#include<time.h>
using namespace std;

int recursions,logictimes,totalbacktracks=0,totalempty=0;
double totalst=0; // IN SECONDS

class sudoku{
public:
time_t beginsolving,endsolving;	// IN TICKS
double solvingtime;				// IN SECONDS
int grid[9][9],posbl[9][9][9],np[9][9],empty;
int is_grid_solved(){
	for(int i=0;i<9;i++){
	for(int j=0;j<9;j++){
		if(grid[i][j]==0){
		return 0;
		}
	}
	}
	return 1;
}
int is_pattern_unsolvable(){
	for(int i=0;i<9;i++){
	for(int j=0;j<9;j++){
		if(np[i][j]==0){
		// Failed Recursion - AND/OR - unsolvable sudoku!
		return 1;
		}
		assert(np[i][j]>=0 || np[i][j]==-5);
	}
	}
	return 0;
}
int checkblanks(){
	int blanks=0;
	for(int i=0;i<9;i++){
	for(int j=0;j<9;j++){
		if(grid[i][j]==0){
		blanks++;
		}
	}
	}
	return (blanks);
}
void inputinit(char *sudokuline){
for(int i=0;i<9;i++){
for(int j=0;j<9;j++){
	grid[i][j]=(*sudokuline++)-48;
		if(!(grid[i][j]>0 && grid[i][j]<10)){
		grid[i][j]=0;
		np[i][j]=9;
			for(int k=0;k<9;k++){
				posbl[i][j][k]=k+1;
			}
		continue;
		}
		np[i][j]=-5;
	// IDEALLY FOR DEBUGGING ONLY
		for(int k=0;k<9;k++){
		posbl[i][j][k]=-1;
		} // REQD. TO REMOVE PREVIOUS GARBAGE VALUES REALLY?
	// IDEALLY FOR DEBUGGING ONLY
	}
	}
if(is_pattern_unsolvable()){
	cout<<"Invalid sudoku entered..."<<endl;
	exit (0); // REMEMBER THAT HERE 0 = FALSE
	}
}
int guess(){
	if(is_pattern_unsolvable()){
	return 0;
	}
	for(int i=0;i<9;i++){
	for(int j=0;j<9;j++){
	if(grid[i][j]==0){
		for(int k=0;k<9;k++){
		if(posbl[i][j][k]!=-1){
			sudoku tmp=*this;
				tmp.grid[i][j]=posbl[i][j][k];
				tmp.np[i][j]=-5;
				for(int x=0;x<9;x++){
					if(tmp.posbl[x][j][k]!=-1){
					tmp.posbl[x][j][k]=-1;
					if(tmp.grid[x][j]==0){
					tmp.np[x][j]--;
					}
					}
					if(tmp.posbl[i][x][k]!=-1){
					tmp.posbl[i][x][k]=-1;
					if(tmp.grid[i][x]==0){
					tmp.np[i][x]--;
					}
					}
				}
				for(int x=3*(int)(i/3);x<3*(int)(i/3)+3;x++){
				for(int y=3*(int)(j/3);y<3*(int)(j/3)+3;y++){
					if(!(x==i && y==j) && tmp.posbl[x][y][k]!=-1){
					tmp.posbl[x][y][k]=-1;
					if(grid[x][y]==0){
					tmp.np[x][y]--;
					}
					}
				}
				}
				recursions++;totalbacktracks++;
				if(tmp.solved()){
					*this=tmp;
					return 1;
				}
		}
		}
		return 0;
	}
	}
	}
	return 0;
}
int solved(){
	if(is_pattern_unsolvable()){
	return 0;
	}
	logic();
	// Logictimes Incremented Here If Reqd.
	// DEBUGGING MAIN POINT !!
	//printsudoku();
	if(is_pattern_unsolvable()){
	return 0;
	}
	if(is_grid_solved()){
	return 1;
	}
	return guess();
}
void logic(){
logictimes++;
int iterations=0,checktcells=checkblanks();
while(checkblanks()!=0 && iterations<100){
	for(int i=0;i<GRIDSIZE;i++){
	for(int j=0;j<GRIDSIZE;j++){
		if(grid[i][j]==0){
		checkrc(i,j);
		checkbox(rows*(int)(i/rows),columns*(int)(j/columns),i,j);
		if(np[i][j]==1){
			for(int k=0;k<GRIDSIZE;k++){
				if(posbl[i][j][k]>0){
				grid[i][j]=posbl[i][j][k]; np[i][j]=-5;
				break;
				}
			}
		}
		rcnootherposbl(i,j);
		nootherposbl(rows*(int)(i/rows),columns*(int)(j/columns),i,j);
		}
	}
	}
	if(checktcells==checkblanks()){
		iterations++;
	}
	else{
		iterations=0;
		checktcells=checkblanks();
	}
}

}
void printsudoku(){
if(checkblanks()==0){
cout<<"Solved Grid:"<<endl;
}
for(int i=0;i<9;i++){
	for(int j=0;j<9;j++){
	cout<<grid[i][j]<<" ";
	}
	cout<<endl;
}
cout<<"Blank cells left are "<<checkblanks()<<endl;
cout<<"Recursions : "<<recursions<<endl;
cout<<endl;
}
void checkrc(int i,int j){
	for(int k=0;k<GRIDSIZE;k++){
	if(posbl[i][j][k]!=-1){
	for(int l=0;l<GRIDSIZE;l++){
		if((posbl[i][j][k]==grid[i][l]) || (posbl[i][j][k]==grid[l][j])){
			posbl[i][j][k]=-1; np[i][j]--;
			assert(np[i][j]>=0 || np[i][j]==-5);
			}
	}
	}
	}
}
void rcnootherposbl(int i,int j){
	for(int k=0;k<GRIDSIZE;k++){
	if(posbl[i][j][k]>0){
		// row done now
		int flag1=0,flag2=1;
			for(int r=0;r<GRIDSIZE;r++){
				if(grid[i][r]==0 && !(r==j)){
					if(posbl[i][r][k]==-1){
					flag1=1;	// flag1=1 => impossible in blank peers and not present in 3x3 box
					}
					else{			
					flag2=0;	// flag2=0 => unknown state of possibility
					}
				}
			}
		if(flag1==1 && flag2==1){
		grid[i][j]=posbl[i][j][k]; np[i][j]=-5;
			for(int z=0;z<GRIDSIZE;z++){
			if(z!=k){
				posbl[i][j][z]=-1;
			}
			}
		break;
		}
		// column done now
		flag1=0;flag2=1;
			for(int c=0;c<GRIDSIZE;c++){
				if(grid[c][j]==0 && !(c==i)){
					if(posbl[c][j][k]==-1){
					flag1=1;	// flag1=1 => impossible in blank peers and not present in 3x3 box
					}
					else{			
					flag2=0;	// flag2=0 => unknown state of possibility
					}
				}
			}
		if(flag1==1 && flag2==1){
		grid[i][j]=posbl[i][j][k]; np[i][j]=-5;
		break;
		}
	}
	}
}
void checkbox(int istart,int jstart,int i,int j){
	for(int t=0;t<GRIDSIZE;t++){
	if(posbl[i][j][t]!=-1){
		for(int k=istart;k<istart+rows && (posbl[i][j][t]!=-1);k++){
		for(int l=jstart;l<jstart+columns && (posbl[i][j][t]!=-1);l++){
			if(grid[k][l]==posbl[i][j][t]){
			posbl[i][j][t]=-1; np[i][j]--;
			assert(np[i][j]>=0 || np[i][j]==-5);
			}
		}
		}
	}
	}
}
void nootherposbl(int istart,int jstart,int i,int j){
	for(int k=0;k<GRIDSIZE;k++){
	if(posbl[i][j][k]>0){
		int flag1=0,flag2=1;
		int x=i/rows,y=j/columns;
		istart=x*rows;jstart=y*columns;
			for(int m=istart;m<istart+rows;m++){
			for(int n=jstart;n<jstart+columns;n++){
				if(grid[m][n]==0 && !(m==i && n==j)){
					if(posbl[m][n][k]==-1){
					flag1=1;	// flag1=1 => impossible in blank peers and not present in 3x3 box
					}
					else{			
					flag2=0;	// flag2=0 => unknown state of possibility
					}
				}
			}
			}
		if(flag1==1 && flag2==1){
		grid[i][j]=posbl[i][j][k]; np[i][j]=-5;
		break;
		}
	}
	}
}
};
int main(){

	char fname[500];
	cin>>fname;
	FILE *sudokudatabase;
	sudokudatabase=fopen(fname,"r");
	if(sudokudatabase==NULL){
	cout<<"Sudoku Database File \""<<fname<<"\" could not be located :<"<<endl;
	return (0);
	}

	char sudokuline[83]; // 81+'\n'+'\0'
	int total=0,unsolved=0;
	while(fgets(sudokuline,83,sudokudatabase)){ // 82 DOES NOT WORK! WHY?
	total++; //sudokuline[81]='\0'; //sudokuline[82]='\0';
	recursions=0,logictimes=0;
	sudoku main;
	main.inputinit(sudokuline);
	totalempty+=(main.empty=main.checkblanks());
	cout<<sudokuline;
	main.beginsolving=clock()/CLOCKS_PER_SEC;
	main.solved();
	main.endsolving=clock()/CLOCKS_PER_SEC;
	if(main.checkblanks()!=0){
		cout<<"Failed solving... (Very unusual if not unsolvable!)"<<endl;
		cout<<"Recursions : "<<recursions<<endl;
		unsolved++; continue;
	}
	else{
		for(int i=0;i<GRIDSIZE;i++){
		for(int j=0;j<GRIDSIZE;j++){
		cout<<main.grid[i][j];
		}
		}
		cout<<endl<<"Cracked puzzle "<<total<<" :) with "<<recursions<<" backtracks ";
	}

	main.solvingtime=main.endsolving-main.beginsolving;
		totalst+=main.solvingtime;
	cout<<"in "<<main.solvingtime<<" seconds!"<<endl<<endl;
		
	}

	cout<<"Solved "<<total-unsolved<<" sudokus out of a total of "<<total<<"!"<<endl;
	cout<<"Average number of recursions is "<<(float)(totalbacktracks)/(float)(total)<<endl;
	cout<<"Average number of blanks is: "<<totalempty/total<<endl;
	cout<<"Average solving time is approximately "<<(float)(totalst)/(total-unsolved)<<" in seconds!"<<endl;
	
	return (1);		// REMEMBER THAT HERE 1 = SUCCESS

}