#include<iostream>
#include<cstdlib>
#include<ctime>
#include<cstdio>
#include"sudokulib.h"
#include<ezwin.h>
#include"rect.h"
#include"bitmap.h"
using namespace std;

sudoku current;
int cellselection[9][9]; // This is used to ensure which cell is selected
int numberselection[9]; // This is used to ensure which number is selected
int given_flag[9][9],check_fn_flag=0;

SimpleWindow MainAppWindow("Sudoku Solver and Generator", 13.0, 14, Position(1.0,1.0));
SimpleWindow SettingsWindow("Menu",3.0,3.0,Position(6.0,6.25));
BitMap Cell(MainAppWindow);

void save_grid(){
	char to_be_saved_linegrid[82];
	int ifilename=time(NULL);
	char sfilename[15]; // 12345678.sdk'\0' = 15 characters
	sprintf(sfilename,"%d.sdk",ifilename);
	FILE *time_sdk;
	time_sdk=fopen(sfilename,"w");
	if(time_sdk==NULL){
		cout<<"Failed to create the file "<<ifilename<<".sdk :("<<endl;
		return;
	}
	current.grid_to_line(current.grid,to_be_saved_linegrid);
	fputs(to_be_saved_linegrid,time_sdk);
	fclose(time_sdk);
	// GUI ALERT
	cout<<"Saved in "<<ifilename<<".sdk"<<endl;
	// GUI ALERT
	return;
}
float stepfn(float a){ // This is greatest integral function which is used in next steps
	int temp;
	temp=a;
	return temp;
}
int menumouseclick(const Position &r){
}
void settings(){
	SettingsWindow.Open();
	SettingsWindow.SetMouseClickCallback(menumouseclick);
}
void render_gridlines(){
	float gridx=2.0,gridy=2.0; // here (gridx,gridy) is the left to grid x corner of the grid
	for (int i=0;i<=9;i++){
		if((i)%3==0){
			MainAppWindow.RenderLine  (Position(gridx+i,gridy), Position(gridx+i,gridy+9),Black, 0.1);
			MainAppWindow.RenderLine  (Position(gridx,gridy+i), Position(gridx+9,gridy+i),Black, 0.1);
		}
		else{
			MainAppWindow.RenderLine  (Position(gridx+i,gridy), Position(gridx+i,gridy+9),Black, 0.0);
			MainAppWindow.RenderLine  (Position(gridx,gridy+i), Position(gridx+9,gridy+i),Black, 0.0);
		}
	}
}
void clear_puzzle_or_cell(){
	for(int i=0;i<9;i++){
	for(int j=0;j<9;j++){
		if(cellselection[i][j]==1){
			if(given_flag[i][j]!=1){
				current.grid[i][j]=0;
				current.np[i][j]=9;
				for(int k=0;k<9;k++){
					current.posbl[i][j][k]=k+1;
				}
				Cell.Load("sblank.xpm"); Cell.SetPosition(Position(2.0+i,2.0+j)); Cell.Draw();
				render_gridlines();
				given_flag[i][j]=0;
			}
			return;
		}
	}
	}
	char confirm;
	// GUI ALERT
	cout<<"Are you sure you want to clear the current grid? (y/n)"<<endl;
	cin>>confirm;
	// GUI ALERT
	if(confirm=='y'){
		current.init_current_obj();
		for(int m=0;m<9;m++){
		for(int n=0;n<9;n++){
			Cell.Load("wblank.xpm"); Cell.SetPosition(Position(2.0+m,2.0+n)); Cell.Draw();
			render_gridlines();
			given_flag[m][n]=0;
		}
		}
	}
}
int execute_generate_algorithm(){
	MainAppWindow.StopTimer();
	int difflevel;
	char is_symmetrical;
	// GUI ALERT
	cout<<"1 - Kiddie - 40 to 45 blanks"<<endl;
	cout<<"2 - Intermediate - 46 to 50 blanks"<<endl;
	cout<<"3 - Quite Tough - 51 to 54 blanks"<<endl;
	cout<<"4 - Exclusive to Pros - 55 to 60 blanks"<<endl;
	cout<<"Enter the desired difficulty level: "<<endl;
	cin>>difflevel;
	cout<<"Do you want a rotationally symmetric puzzle pleasing to the eyes? (y,n)"<<endl;
	cin>>is_symmetrical;
	// GUI ALERT
	if(is_symmetrical!='n'){
		if(is_symmetrical!='y'){
			// GUI ALERT
			cout<<"Arbit Nonsense!? Symmetry Assumed :}"<<endl;
			// GUI ALERT
		}
		is_puzzle_symmetric=1;
	}
	else{
		is_puzzle_symmetric=0;
	}
	current.init_current_obj();
	generate(difflevel);
	current.line_to_grid(new_question_linegrid);
	for(int m=0;m<9;m++){
	for(int n=0;n<9;n++){
		if(current.grid[m][n]==0){
			Cell.Load("wblank.xpm"); Cell.SetPosition(Position(2.0+m,2.0+n)); Cell.Draw();
			given_flag[m][n]=0;
		}
		else{
			char bitmap_name[10];
			sprintf(bitmap_name,"grey%d.xpm",current.grid[m][n]);
			given_flag[m][n]=1;
			Cell.Load(bitmap_name); Cell.SetPosition(Position(2.0+m,2.0+n)); Cell.Draw();
		}
		render_gridlines();
	}
	}
}
void execute_solve_algorithm(){
	current.grid_to_line(current.grid,user_given_linegrid);
	try_to_solve(user_given_linegrid);
	if(multiple==1){
		current.line_to_grid(solution_linegrid);
		int count=0;
		for(int m=0;m<9;m++){
		for(int n=0;n<9;n++){
			if(!(given_flag[m][n]==1 || user_given_linegrid[count]==solution_linegrid[count])){
				char bitmap_name[10];
				sprintf(bitmap_name,"w%d.xpm",current.grid[m][n]);
				Cell.Load(bitmap_name); Cell.SetPosition(Position(2.0+m,2.0+n)); Cell.Draw();
			}
			count++;
			render_gridlines();
		}
		}
	}
	else if(multiple<500 && multiple>0){
		// GUI ALERT
		cout<<multiple<<" solutions found, hence grid supplied is invalid!"<<endl;
		// GUI ALERT
	}
	else if(multiple==500){
		// GUI ALERT
		cout<<"At least 500 solutions possible, hence grid supplied is invalid!"<<endl;
		// GUI ALERT
	}
	else if(multiple>500){
		// GUI ALERT
		cout<<"At least ?"<<multiple<<"? solutions possible, hence grid supplied is invalid! (This stage should NOT be reached at all) :{"<<endl;
		// GUI ALERT
	}
	else{
		// GUI ALERT
		cout<<"Current grid (tried to be solved) has no possible solution or is blank!"<<endl;
		// GUI ALERT
	}
}
void check(){
	try_to_solve(new_question_linegrid);
	if(multiple==1){
		sudoku cross_check;
		cross_check.line_to_grid(solution_linegrid);
		check_fn_flag=1;
		for(int m=0;m<9;m++){
		for(int n=0;n<9;n++){
			if(current.grid[m][n]!=0 && given_flag[m][n]==0){
				if(current.grid[m][n]==cross_check.grid[m][n]){
					char bitmap_name[10];
					sprintf(bitmap_name,"g%d.xpm",current.grid[m][n]);
					Cell.Load(bitmap_name); Cell.SetPosition(Position(2.0+m,2.0+n)); Cell.Draw();
				}
				else{
					char bitmap_name[10];
					sprintf(bitmap_name,"r%d.xpm",current.grid[m][n]);
					Cell.Load(bitmap_name); Cell.SetPosition(Position(2.0+m,2.0+n)); Cell.Draw();
				}
				render_gridlines();
			}
		}
		}
	}
	else if(multiple<500 && multiple>0){
		// GUI ALERT
		cout<<multiple<<" solutions found, hence grid supplied is invalid!"<<endl;
		// GUI ALERT
	}
	else if(multiple==500){
		// GUI ALERT
		cout<<"At least 500 solutions possible, hence grid supplied is invalid!"<<endl;
		// GUI ALERT
	}
	else if(multiple>500){
		// GUI ALERT
		cout<<"At least ?"<<multiple<<"? solutions possible, hence grid supplied is invalid! (This stage should NOT be reached at all) :{"<<endl;
		// GUI ALERT
	}
	else{
		// GUI ALERT
		cout<<"Question grid not given!"<<endl;
		// GUI ALERT
	}
}
//void display_dialog_hint(){}
int generate_timer_event(){
		MainAppWindow.StopTimer();
		MainAppWindow.SetTimerCallback(execute_generate_algorithm);
		MainAppWindow.StartTimer(25);
		Cell.Load("tabbed_main_buttons_inactive.xpm");
		Cell.SetPosition(Position(1.25,0.56));
		Cell.Draw();
}
int wmouseclick(const Position &p){
	float x = p.GetXDistance();
	float y = p.GetYDistance();
	int temp_x = stepfn(x);
	int temp_y = stepfn(y);
	if((x>1.2 && x<3.3) && ((temp_y==0)||(temp_y==1))){
		settings();
	}
	else if((x>3.3 && x<5.4) && ((temp_y==0)||(temp_y==1))){
		Cell.Load("generate.xpm");
		Cell.SetPosition(Position(3.3,0.56));
		Cell.Draw();
		MainAppWindow.SetTimerCallback(generate_timer_event); // This is similar to mouseclickcallback
		MainAppWindow.StartTimer(150); // Now generate_timer_event is invoked for every 100 millisecond
	}
	else if((x>7.5 && x<9.6) && ((temp_y==0)||(temp_y==1))){
		execute_solve_algorithm();
	}
	if(check_fn_flag==1){
		for(int m=0;m<9;m++){
		for(int n=0;n<9;n++){
			if(current.grid[m][n]!=0 && given_flag[m][n]!=1){
				char bitmap_name[10];
				sprintf(bitmap_name,"w%d.xpm",current.grid[m][n]);
				Cell.Load(bitmap_name); Cell.SetPosition(Position(2.0+m,2.0+n)); Cell.Draw();
			}
			render_gridlines();
		}
		}
		check_fn_flag=0;	
	}
	else if((x>9.6 && x<11.7) && ((temp_y==0)||(temp_y==1))){
		check();
	}
	if((x>5.4 && x<7.5) && ((temp_y==0)||(temp_y==1))){
		clear_puzzle_or_cell();
	}
	else{		
		if(((temp_x>=2)&&(temp_x<=11))&&((temp_y>=2)&&(temp_y<=11))){ // This is to store the selected cell in grid
			for(int i=0;i<9;i++){
			for(int j=0;j<9;j++){
				if((temp_x==2+i)&&(temp_y==2+j)){
					cellselection[i][j]=1;
					if(current.grid[i][j]==0){
						Cell.Load("sblank.xpm"); Cell.SetPosition(Position(2.0+i,2.0+j)); Cell.Draw();
					}
					else{
						char bitmap_name[10];
						sprintf(bitmap_name,"s%d.xpm",current.grid[i][j]);
						Cell.Load(bitmap_name); Cell.SetPosition(Position(2.0+i,2.0+j)); Cell.Draw();
					}
					render_gridlines();
				}
				else{
					if(cellselection[i][j]==1){
						if(current.grid[i][j]==0){
							Cell.Load("wblank.xpm"); Cell.SetPosition(Position(2.0+i,2.0+j)); Cell.Draw();
						}
						else{
							char bitmap_name[10];
							if(given_flag[i][j]==1){
							sprintf(bitmap_name,"grey%d.xpm",current.grid[i][j]);
							}
							else{
							sprintf(bitmap_name,"w%d.xpm",current.grid[i][j]);
							}
							Cell.Load(bitmap_name); Cell.SetPosition(Position(2.0+i,2.0+j)); Cell.Draw();
						}
						render_gridlines();
						cellselection[i][j]=0;
					}
				}
			}
			}
		}
		if(temp_y==12){	
			for(int i=0;i<9;i++){ // This is to store which number is selected
				if(temp_x==2+i){
					numberselection[i]=1;
				}
				else{
					numberselection[i]=0;
				}
			}
			for (int k=0;k<9;k++){
				if(numberselection[k]==1){
					for (int i=0;i<9;i++){
					for (int j=0;j<9;j++){
						if(cellselection[i][j]==1 && given_flag[i][j]==0){
							char bitmap_name[10];
							sprintf(bitmap_name,"s%d.xpm",(k+1));	
							Cell.Load(bitmap_name); Cell.SetPosition(Position(2.0+i,2.0+j)); Cell.Draw();
							current.grid[i][j]=k+1;
							current.decorated_sudoku(); // debugging
							render_gridlines();
						}
					}
					}
				}
			}
		}
	}
}
void window_grid_start(){ // a 9x9 grid is generated and numbers are shown which are to be clicked for choosing
	float gridx=2.0,gridy=2.0; // here (gridx,gridy) is the left togridx corner of the grid  
	MainAppWindow.Open(); assert( MainAppWindow.GetStatus() == WindowOpen );
	for(int i=0;i<9;i++){	
		numberselection[i]=0;
		for(int j=0;j<9;j++){
			cellselection[i][j]=0;
		}
	}
	Cell.Load("tabbed_main_buttons_inactive.xpm"); Cell.SetPosition(Position(1.25,0.56)); Cell.Draw();
	for(int i=1;i<10;i++){ // The following steps are for printing numbers
		char bitmap_name[10];
		sprintf(bitmap_name,"k%d.xpm",i);
		Cell.Load(bitmap_name);
		Cell.SetPosition(Position(1.0+i,12.0));
		Cell.Draw();
	}
	MainAppWindow.SetMouseClickCallback(wmouseclick);
	for (int i=0;i<9;i++){
	for (int j=0;j<9;j++){
		if(current.grid[i][j]==0){
			Cell.Load("wblank.xpm"); Cell.SetPosition(Position(2.0+i,2.0+j)); Cell.Draw();
			given_flag[i][j]=0;
		}
		else{
			char bitmap_name[10];
			sprintf(bitmap_name,"grey%d.xpm",current.grid[i][j]);
			given_flag[i][j]=1;
			Cell.Load(bitmap_name); Cell.SetPosition(Position(2.0+i,2.0+j)); Cell.Draw();
		}
		render_gridlines();
	}
	}
}
int ApiMain(){
	current.init_current_obj();
	window_grid_start();
	return (0);
}
