#include<iostream>
#include<cstdlib>
#include<ctime>
#include<cstdio>
#include"sudokulib.h"
#include<ezwin.h>
#include"rect.h"
#include"bitmap.h"
using namespace std;

sudoku current;
int cellselection[9][9]; // This is used to ensure which cell is selected
int numberselection[9]; // This is used to ensure which number is selected
int given_flag[9][9],check_fn_flag=0;
char hint_text[500];

SimpleWindow MainAppWindow("Sudoku Solver and Generator", 13.0, 14, Position(1.0,1.0));
SimpleWindow SettingsWindow("Menu",3.0,3.0,Position(6.0,6.25));
BitMap Cell(MainAppWindow);

void save_grid(){
	char to_be_saved_linegrid[82];
	int ifilename=time(NULL);
	char sfilename[15]; // 12345678.sdk'\0' = 15 characters
	sprintf(sfilename,"%d.sdk",ifilename);
	FILE *time_sdk;
	time_sdk=fopen(sfilename,"w");
	if(time_sdk==NULL){
		cout<<"Failed to create the file "<<ifilename<<".sdk :("<<endl;
		return;
	}
	current.grid_to_line(current.grid,to_be_saved_linegrid);
	fputs(to_be_saved_linegrid,time_sdk);
	fclose(time_sdk);
	// GUI ALERT
	cout<<"Saved in "<<ifilename<<".sdk"<<endl;
	// GUI ALERT
	return;
}
float stepfn(float a){ // This is greatest integral function which is used in next steps
	int temp;
	temp=a;
	return temp;
}
int menumouseclick(const Position &r){
}
int settings(){
	MainAppWindow.StopTimer();
	SettingsWindow.Open();
	SettingsWindow.SetMouseClickCallback(menumouseclick);
}
void render_gridlines(){
	float gridx=2.0,gridy=2.0; // here (gridx,gridy) is the left to grid x corner of the grid
	for (int i=0;i<=9;i++){
		if((i)%3==0){
			MainAppWindow.RenderLine  (Position(gridx+i,gridy), Position(gridx+i,gridy+9),Black, 0.1);
			MainAppWindow.RenderLine  (Position(gridx,gridy+i), Position(gridx+9,gridy+i),Black, 0.1);
		}
		else{
			MainAppWindow.RenderLine  (Position(gridx+i,gridy), Position(gridx+i,gridy+9),Black, 0.0);
			MainAppWindow.RenderLine  (Position(gridx,gridy+i), Position(gridx+9,gridy+i),Black, 0.0);
		}
	}
}
int clear_puzzle_or_cell(){
	MainAppWindow.StopTimer();
	int single_clear_flag=0;
	for(int i=0;i<9;i++){
	for(int j=0;j<9;j++){
		if(cellselection[i][j]==1){
			if(given_flag[i][j]!=1){
				current.grid[i][j]=0;
				current.np[i][j]=9;
				for(int k=0;k<9;k++){
					current.posbl[i][j][k]=k+1;
				}
				Cell.Load("sblank.xpm"); Cell.SetPosition(Position(2.0+i,2.0+j)); Cell.Draw();
				render_gridlines();
				given_flag[i][j]=0;
			}
			single_clear_flag=1;
		}
	}
	}
	if(single_clear_flag==0){
		char confirm;
		// GUI ALERT
		cout<<"Are you sure you want to clear the current grid? (y/n)"<<endl;
		cin>>confirm;
		// GUI ALERT
		if(confirm=='y'){
			current.init_current_obj();
			for(int m=0;m<9;m++){
			for(int n=0;n<9;n++){
				Cell.Load("wblank.xpm"); Cell.SetPosition(Position(2.0+m,2.0+n)); Cell.Draw();
				render_gridlines();
				given_flag[m][n]=0;
			}
			}
		}
	}
}
int generatehint(){
	char for_hint_linegrid[82];
	for(int count=0;count<500;count++){
		hint_text[count]='X';
	}
	current.grid_to_line(current.grid,for_hint_linegrid);
	sudoku for_hint;
	for_hint.init_for_solver(for_hint_linegrid);
	for_hint.logic();
	int hint_given_flag=0;
	for(int m=0;m<9;m++){
		for(int n=0;n<9;n++){
			if(current.grid[m][n]==0 && (current.np[m][n]==1 || for_hint.np[m][n]==1)){
				sprintf(hint_text,"There is just 1 possibility at cell (%d,%d)!",n,m);
				cout<<hint_text<<endl;
				hint_given_flag=1;
				break;
			}
			else if(current.grid[m][n]==0 && for_hint.np[m][n]==-5){
				sprintf(hint_text,"Try working on cell (%d,%d)!",n,m);
				cout<<hint_text<<endl;
				hint_given_flag=1;
				break;
			}
		}
		if(hint_given_flag=1){
			break;
		}
	}
	if(hint_given_flag==0){
		sprintf(hint_text,"Sorry, no hint could be automatically generated. Try making me solve entire puzzle instead!");
		cout<<hint_text<<endl;
	}
}
int execute_generate_algorithm(){
	MainAppWindow.StopTimer();
	char is_symmetrical;
	// GUI ALERT
	cout<<"1 - Kiddie - 40 to 45 blanks"<<endl;
	cout<<"2 - Intermediate - 46 to 50 blanks"<<endl;
	cout<<"3 - Quite Tough - 51 to 54 blanks"<<endl;
	cout<<"4 - Exclusive to Pros - 55 to 60 blanks"<<endl;
	cout<<"Enter the desired difficulty level: "<<endl;
	cin>>difflevel;
	cout<<"Do you want a rotationally symmetric puzzle pleasing to the eyes? (y,n)"<<endl;
	cin>>is_symmetrical;
	// GUI ALERT
	if(is_symmetrical!='n'){
		if(is_symmetrical!='y'){
			// GUI ALERT
			cout<<"Arbit Nonsense!? Symmetry Assumed :}"<<endl;
			// GUI ALERT
		}
		is_puzzle_symmetric=1;
	}
	else{
		is_puzzle_symmetric=0;
	}
	current.init_current_obj();
	generate();
	current.line_to_grid(new_question_linegrid);
	for(int m=0;m<9;m++){
	for(int n=0;n<9;n++){
		if(current.grid[m][n]==0){
			Cell.Load("wblank.xpm"); Cell.SetPosition(Position(2.0+m,2.0+n)); Cell.Draw();
			given_flag[m][n]=0;
		}
		else{
			char bitmap_name[10];
			sprintf(bitmap_name,"grey%d.xpm",current.grid[m][n]);
			given_flag[m][n]=1;
			Cell.Load(bitmap_name); Cell.SetPosition(Position(2.0+m,2.0+n)); Cell.Draw();
		}
		render_gridlines();
	}
	}
}
int execute_solve_algorithm(){
	MainAppWindow.StopTimer();
	current.grid_to_line(current.grid,user_given_linegrid);
	try_to_solve(user_given_linegrid);
	if(multiple==1){
		char hint_choice;
		cout<<"Want just a hint? (y/n) ";
		cin>>hint_choice;
		if(hint_choice!='n'){
			generatehint();
		}
		else{
			current.line_to_grid(solution_linegrid);
			int count=0;
			for(int m=0;m<9;m++){
			for(int n=0;n<9;n++){
				if(!(given_flag[m][n]==1 || user_given_linegrid[count]==solution_linegrid[count])){
					char bitmap_name[10];
					sprintf(bitmap_name,"w%d.xpm",current.grid[m][n]);
					Cell.Load(bitmap_name); Cell.SetPosition(Position(2.0+m,2.0+n)); Cell.Draw();
				}
				count++;
				render_gridlines();
			}
			}
		}
	}
	else if(multiple<500 && multiple>0){
		// GUI ALERT
		cout<<multiple<<" solutions found, hence grid supplied is invalid!"<<endl;
		// GUI ALERT
	}
	else if(multiple==500){
		// GUI ALERT
		cout<<"At least 500 solutions possible, hence grid supplied is invalid!"<<endl;
		// GUI ALERT
	}
	else if(multiple>500){
		// GUI ALERT
		cout<<"At least ?"<<multiple<<"? solutions possible, hence grid supplied is invalid! (This stage should NOT be reached at all) :{"<<endl;
		// GUI ALERT
	}
	else{
		// GUI ALERT
		cout<<"Current grid (tried to be solved) has no possible solution or is blank!"<<endl;
		// GUI ALERT
	}
}
int check(){
	MainAppWindow.StopTimer();
	if(check_fn_flag!=1){
		try_to_solve(new_question_linegrid);
		if(multiple==1){
			sudoku cross_check;
			cross_check.line_to_grid(solution_linegrid);
			check_fn_flag=1;
			for(int m=0;m<9;m++){
			for(int n=0;n<9;n++){
				if(current.grid[m][n]!=0 && given_flag[m][n]==0){
					if(current.grid[m][n]==cross_check.grid[m][n]){
						char bitmap_name[10];
						sprintf(bitmap_name,"g%d.xpm",current.grid[m][n]);
						Cell.Load(bitmap_name); Cell.SetPosition(Position(2.0+m,2.0+n)); Cell.Draw();
					}
					else{
						char bitmap_name[10];
						sprintf(bitmap_name,"r%d.xpm",current.grid[m][n]);
						Cell.Load(bitmap_name); Cell.SetPosition(Position(2.0+m,2.0+n)); Cell.Draw();
					}
					render_gridlines();
				}
			}
			}
		}
		else if(multiple<500 && multiple>0){
			// GUI ALERT
			cout<<multiple<<" solutions found, hence grid supplied is invalid!"<<endl;
			// GUI ALERT
		}
		else if(multiple==500){
			// GUI ALERT
			cout<<"At least 500 solutions possible, hence grid supplied is invalid!"<<endl;
			// GUI ALERT
		}
		else if(multiple>500){
			// GUI ALERT
			cout<<"At least ?"<<multiple<<"? solutions possible, hence grid supplied is invalid! (This stage should NOT be reached at all) :{"<<endl;
			// GUI ALERT
		}
		else{
			// GUI ALERT
			cout<<"Question grid not given or unsolvable!"<<endl;
			// GUI ALERT
		}
	}
}
void load_inactive_tabbed_bar(){
	Cell.Load("tabbed_main_buttons_inactive.xpm");
	Cell.SetPosition(Position(1.25,0.56));
	Cell.Draw();
}
int complete_event_1(){
	MainAppWindow.StopTimer();
	MainAppWindow.SetTimerCallback(settings);
	MainAppWindow.StartTimer(30);
	load_inactive_tabbed_bar();
}
int complete_event_2(){
	MainAppWindow.StopTimer();
	MainAppWindow.SetTimerCallback(execute_generate_algorithm);
	MainAppWindow.StartTimer(30);
	load_inactive_tabbed_bar();
}
int complete_event_3(){
	MainAppWindow.StopTimer();
	MainAppWindow.SetTimerCallback(clear_puzzle_or_cell);
	MainAppWindow.StartTimer(30);
	load_inactive_tabbed_bar();
}
int complete_event_4(){
	MainAppWindow.StopTimer();
	MainAppWindow.SetTimerCallback(execute_solve_algorithm);
	MainAppWindow.StartTimer(30);
	load_inactive_tabbed_bar();
}
int complete_event_5(){
	MainAppWindow.StopTimer();
	MainAppWindow.SetTimerCallback(check);
	MainAppWindow.StartTimer(30);
	load_inactive_tabbed_bar();
}
void activate_button(int which_button){
	char xpm_file[50];
	float x_posn;
	switch(which_button){
		case 1:
			x_posn=1.25;
			sprintf(xpm_file,"settings.xpm");
			break;
		case 2:
			x_posn=3.3;
			sprintf(xpm_file,"generate.xpm");
			break;
		case 3:
			x_posn=5.4;
			sprintf(xpm_file,"clear.xpm");
			break;
		case 4:
			x_posn=7.5;
			sprintf(xpm_file,"solve.xpm");
			break;
		case 5:
			x_posn=9.6;
			sprintf(xpm_file,"check.xpm");
			break;
	}
	Cell.Load(xpm_file);
	Cell.SetPosition(Position(x_posn,0.56));
	Cell.Draw();
	switch(which_button){
		case 1:
			MainAppWindow.SetTimerCallback(complete_event_1); // This is similar to mouseclickcallback
			break;
		case 2:
			MainAppWindow.SetTimerCallback(complete_event_2); // This is similar to mouseclickcallback
			break;
		case 3:
			MainAppWindow.SetTimerCallback(complete_event_3); // This is similar to mouseclickcallback
			break;
		case 4:
			MainAppWindow.SetTimerCallback(complete_event_4); // This is similar to mouseclickcallback
			break;
		case 5:
			MainAppWindow.SetTimerCallback(complete_event_5); // This is similar to mouseclickcallback
			break;
	}
	MainAppWindow.StartTimer(80); // Now generate_timer_event is invoked for every 100 millisecond
}
int wmouseclick(const Position &p){
	float x = p.GetXDistance();
	float y = p.GetYDistance();
	int temp_x = stepfn(x);
	int temp_y = stepfn(y);
	if((x>1.2 && x<3.3) && ((temp_y==0)||(temp_y==1))){
		activate_button(1);
	}
	else if((x>3.3 && x<5.4) && ((temp_y==0)||(temp_y==1))){
		activate_button(2);
	}
	else if((x>7.5 && x<9.6) && ((temp_y==0)||(temp_y==1))){
		activate_button(4);
	}
	if((x>9.6 && x<11.7) && ((temp_y==0)||(temp_y==1))){
		activate_button(5);
	}
	else if(check_fn_flag==1 && !((x>1.2 && x<3.3) && ((temp_y==0)||(temp_y==1))) && !((x>5.4 && x<7.5) && ((temp_y==0)||(temp_y==1)))){
		for(int m=0;m<9;m++){
		for(int n=0;n<9;n++){
			if(current.grid[m][n]!=0 && given_flag[m][n]!=1){
				char bitmap_name[10];
				sprintf(bitmap_name,"w%d.xpm",current.grid[m][n]);
				Cell.Load(bitmap_name); Cell.SetPosition(Position(2.0+m,2.0+n)); Cell.Draw();
			}
			render_gridlines();
		}
		}
		check_fn_flag=0;	
	}	
	if((x>5.4 && x<7.5) && ((temp_y==0)||(temp_y==1))){
		activate_button(3);
	}
	else{		
		if(((temp_x>=2)&&(temp_x<=11))&&((temp_y>=2)&&y<11.5)){ // This is to store the selected cell in grid
			for(int i=0;i<9;i++){
			for(int j=0;j<9;j++){
				if((temp_x==2+i)&&(temp_y==2+j)){
					cellselection[i][j]=1;
					if(current.grid[i][j]==0){
						Cell.Load("sblank.xpm"); Cell.SetPosition(Position(2.0+i,2.0+j)); Cell.Draw();
					}
					else{
						char bitmap_name[10];
						sprintf(bitmap_name,"s%d.xpm",current.grid[i][j]);
						Cell.Load(bitmap_name); Cell.SetPosition(Position(2.0+i,2.0+j)); Cell.Draw();
					}
					render_gridlines();
				}
				else{
					if(cellselection[i][j]==1){
						if(current.grid[i][j]==0){
							Cell.Load("wblank.xpm"); Cell.SetPosition(Position(2.0+i,2.0+j)); Cell.Draw();
						}
						else{
							char bitmap_name[10];
							if(given_flag[i][j]==1){
							sprintf(bitmap_name,"grey%d.xpm",current.grid[i][j]);
							}
							else{
							sprintf(bitmap_name,"w%d.xpm",current.grid[i][j]);
							}
							Cell.Load(bitmap_name); Cell.SetPosition(Position(2.0+i,2.0+j)); Cell.Draw();
						}
						render_gridlines();
						cellselection[i][j]=0;
					}
				}
			}
			}
		}
		if(y>11.5 && y<12.5){	
			for(int i=0;i<9;i++){ // This is to store which number is selected
				if(temp_x==2+i){
					numberselection[i]=1;
				}
				else{
					numberselection[i]=0;
				}
			}
			for (int k=0;k<9;k++){
				if(numberselection[k]==1){
					for (int i=0;i<9;i++){
					for (int j=0;j<9;j++){
						if(cellselection[i][j]==1 && given_flag[i][j]==0){
							char bitmap_name[10];
							sprintf(bitmap_name,"s%d.xpm",(k+1));	
							Cell.Load(bitmap_name); Cell.SetPosition(Position(2.0+i,2.0+j)); Cell.Draw();
							current.grid[i][j]=k+1;
							current.decorated_sudoku(); // debugging
							render_gridlines();
						}
					}
					}
				}
			}
		}
	}
}
void window_grid_start(){ // a 9x9 grid is generated and numbers are shown which are to be clicked for choosing
	float gridx=2.0,gridy=2.0; // here (gridx,gridy) is the left togridx corner of the grid  
	MainAppWindow.Open();
	if(!(MainAppWindow.GetStatus()==WindowOpen)){
		cout<<"Error Opening Window :("<<endl;
	}
	for(int i=0;i<9;i++){	
		numberselection[i]=0;
		for(int j=0;j<9;j++){
			cellselection[i][j]=0;
		}
	}
	load_inactive_tabbed_bar();
	for(int i=1;i<10;i++){ // The following steps are for printing numbers
		char bitmap_name[10];
		sprintf(bitmap_name,"k%d.xpm",i);
		Cell.Load(bitmap_name);
		Cell.SetPosition(Position(1.0+i,11.5));
		Cell.Draw();
	}
	MainAppWindow.SetMouseClickCallback(wmouseclick);
	for (int i=0;i<9;i++){
	for (int j=0;j<9;j++){
		if(current.grid[i][j]==0){
			Cell.Load("wblank.xpm"); Cell.SetPosition(Position(2.0+i,2.0+j)); Cell.Draw();
			given_flag[i][j]=0;
		}
		else{
			char bitmap_name[10];
			sprintf(bitmap_name,"grey%d.xpm",current.grid[i][j]);
			given_flag[i][j]=1;
			Cell.Load(bitmap_name); Cell.SetPosition(Position(2.0+i,2.0+j)); Cell.Draw();
		}
		render_gridlines();
	}
	}
}
int ApiMain(){
	current.init_current_obj();
	window_grid_start();
	return (0);
}