#include<iostream>
#include<stdio.h>
#include<cstdlib>
#include<ctime>
#include<cstdio>
#include"sudokulib.h"
#include<ezwin.h>
#include"rect.h"
#include"bitmap.h"
#include "randint.h"
using namespace std;

sudoku current;
int cellselection[9][9]; // This is used to ensure which cell is selected
int numberselection[9]; // This is used to ensure which number is selected
int given_flag[9][9],check_fn_flag=0;
int difflevel=1;

SimpleWindow MainAppWindow("Sudoku Solver and Generator", 13.0, 14.0, Position(1.0,1.0));
SimpleWindow SettingsWindow("Menu",10.0,10.0,Position(2.5,3.0));
SimpleWindow MessageWindow("Message", 12.0,4.0, Position(2.0, 6.0));

BitMap Cell(MainAppWindow),Image1(SettingsWindow),Image2(SettingsWindow),Image3(SettingsWindow),ok(MessageWindow);

int totalpuzzle_time_in_seconds = 0;
int time_seconds=0;
int time_minutes=0;
int has_generator_been_used=0;
int timer(){
	if(has_generator_been_used){
	time_seconds=totalpuzzle_time_in_seconds%60;
	time_minutes=totalpuzzle_time_in_seconds/60;
	char mystring[20];
	sprintf(mystring, "Time elapsed is %d:%d",time_minutes,time_seconds);
	MainAppWindow.RenderRectangle(Position(5, 13.0),Position(9.0,14.0),White,false);
	MainAppWindow.RenderText(Position(5, 13.0),Position(9.0,14.0), mystring);
	totalpuzzle_time_in_seconds++;
	}
}
void save_grid(){
	char to_be_saved_linegrid[82];
	int ifilename=time(NULL);
	char sfilename[15]; // 12345678.sdk'\0' = 15 characters
	sprintf(sfilename,"%d.sdk",ifilename);
	FILE *time_sdk;
	time_sdk=fopen(sfilename,"w");
	if(time_sdk==NULL){
		cout<<"Failed to create the file "<<ifilename<<".sdk :("<<endl;
		return;
	}
	current.grid_to_line(current.grid,to_be_saved_linegrid);
	fputs(to_be_saved_linegrid,time_sdk);
	fclose(time_sdk);
	// GUI ALERT
	cout<<"Saved in "<<ifilename<<".sdk"<<endl;
	// GUI ALERT
	return;
}
float stepfn(float a){ // This is greatest integral function which is used in next steps
	int temp;
	temp=a;
	return temp;
}
int menumouseclick(const Position &r){
	float x1 = r.GetXDistance();
	float y1 = r.GetYDistance();
	int temp_x1 = stepfn(x1);
	int temp_y1 = stepfn(y1);
	if(temp_y1==0){
		if(x1<=1.3){
		SettingsWindow.Close();
		}
		else if(x1>=8.7){
		SettingsWindow.Close();
		MainAppWindow.Close();
		}
	}
 	else if(y1>6.07&&y1<6.96){
		Image3.Load("no.xpm");Image3.SetPosition(Position(6.75,6.29)); Image3.Draw();
	}
	else if(y1>7.87&&y1<8.78){
		if(is_puzzle_symmetric=0){
		is_puzzle_symmetric=1;
		Image2.Load("yes.xpm");Image2.SetPosition(Position(6.75,8.09)); Image2.Draw();
		}
		if(is_puzzle_symmetric=1){
		is_puzzle_symmetric=0;
		Image2.Load("no.xpm");Image2.SetPosition(Position(6.75,8.09)); Image2.Draw();
		}
	}
	if(y1>2&&y1<2.93){
		Image1.Load("tick.xpm");Image1.Erase();Image1.SetPosition(Position(5.5,2.25));Image1.Draw();
		difflevel=1;
	}
	else if(y1>2.93&&y1<3.85){
		Image1.Load("tick.xpm");Image1.Erase();Image1.SetPosition(Position(5.5,3.22));Image1.Draw();
		difflevel=2;
	}
	else if(y1>3.85&&y1<4.78){
		Image1.Load("tick.xpm");Image1.Erase();Image1.SetPosition(Position(5.5,4.19));Image1.Draw();
		difflevel=3;
	}
	else if(y1>4.78&&y1<5.70){
		Image1.Load("tick.xpm");Image1.Erase();Image1.SetPosition(Position(5.5,5.16));Image1.Draw();
		difflevel=4;
	}
}
int settings(){
	MainAppWindow.StopTimer();
	MainAppWindow.SetTimerCallback(timer);
	MainAppWindow.StartTimer(1000);
	SettingsWindow.Open();
	SettingsWindow.SetMouseClickCallback(menumouseclick);
	Image1.Load("settingswindow.xpm");Image1.SetPosition(Position(0.0,0.0)); Image1.Draw();
	Image2.Load("yes.xpm");Image2.SetPosition(Position(6.75,8.09)); Image2.Draw();
	 if(difflevel==1){	Image1.Load("tick.xpm");Image1.Erase();Image1.SetPosition(Position(5.5,2.25));Image1.Draw();}
else if(difflevel==2){	Image1.Load("tick.xpm");Image1.Erase();Image1.SetPosition(Position(5.5,3.22));Image1.Draw();}
else if(difflevel==3){	Image1.Load("tick.xpm");Image1.Erase();Image1.SetPosition(Position(5.5,4.19));Image1.Draw();}
else if(difflevel==4){	Image1.Load("tick.xpm");Image1.Erase();Image1.SetPosition(Position(5.5,5.16));Image1.Draw();}
}

void render_gridlines(){
	float gridx=2.0,gridy=2.0; // here (gridx,gridy) is the left to grid x corner of the grid
	for (int i=0;i<=9;i++){
		if((i)%3==0){
			MainAppWindow.RenderLine  (Position(gridx+i,gridy), Position(gridx+i,gridy+9),Black, 0.1);
			MainAppWindow.RenderLine  (Position(gridx,gridy+i), Position(gridx+9,gridy+i),Black, 0.1);
		}
		else{
			MainAppWindow.RenderLine  (Position(gridx+i,gridy), Position(gridx+i,gridy+9),Black, 0.0);
			MainAppWindow.RenderLine  (Position(gridx,gridy+i), Position(gridx+9,gridy+i),Black, 0.0);
		}
	}
}
int clear_puzzle_or_cell(){
	MainAppWindow.StopTimer();
	MainAppWindow.SetTimerCallback(timer);
	MainAppWindow.StartTimer(1000);
	int single_clear_flag=0;
	for(int i=0;i<9;i++){
	for(int j=0;j<9;j++){
		if(cellselection[i][j]==1){
			if(given_flag[i][j]!=1){
				current.grid[i][j]=0;
				current.np[i][j]=9;
				for(int k=0;k<9;k++){
					current.posbl[i][j][k]=k+1;
				}
				Cell.Load("sblank.xpm"); Cell.SetPosition(Position(2.0+i,2.0+j)); Cell.Draw();
				render_gridlines();
				given_flag[i][j]=0;
			}
			single_clear_flag=1;
		}
	}
	}
	if(single_clear_flag==0){
		char confirm;
		// GUI ALERT
		cout<<"Are you sure you want to clear the current grid? (y/n)"<<endl;
		cin>>confirm;
		// GUI ALERT
		if(confirm=='y'){
			current.init_current_obj();
			for(int m=0;m<9;m++){
			for(int n=0;n<9;n++){
				Cell.Load("wblank.xpm"); Cell.SetPosition(Position(2.0+m,2.0+n)); Cell.Draw();
				render_gridlines();
				given_flag[m][n]=0;
			}
			}
		}
	}
}
int execute_generate_algorithm(){
	has_generator_been_used=1;
	totalpuzzle_time_in_seconds = 0;
	MainAppWindow.StopTimer();
	MainAppWindow.SetTimerCallback(timer);
	MainAppWindow.StartTimer(1000);

	cout<<"Do you want a rotationally symmetric puzzle pleasing to the eyes? (y,n)"<<endl;
	cin>>is_symmetrical;
	// GUI ALERT
	if(is_symmetrical!='n'){
		if(is_symmetrical!='y'){
			// GUI ALERT
			cout<<"Arbit Nonsense!? Symmetry Assumed :}"<<endl;
			// GUI ALERT
		}
		is_puzzle_symmetric=1;
	}
	else{
		is_puzzle_symmetric=0;
	}
*/
	current.init_current_obj();
	generate(difflevel);
	current.line_to_grid(new_question_linegrid);
	for(int m=0;m<9;m++){
	for(int n=0;n<9;n++){
		if(current.grid[m][n]==0){
			Cell.Load("wblank.xpm"); Cell.SetPosition(Position(2.0+m,2.0+n)); Cell.Draw();
			given_flag[m][n]=0;
		}
		else{
			char bitmap_name[10];
			sprintf(bitmap_name,"grey%d.xpm",current.grid[m][n]);
			given_flag[m][n]=1;
			Cell.Load(bitmap_name); Cell.SetPosition(Position(2.0+m,2.0+n)); Cell.Draw();
		}
		render_gridlines();
	}
	}
}
int execute_solve_algorithm(){
	MainAppWindow.StopTimer();
	current.grid_to_line(current.grid,user_given_linegrid);
	try_to_solve(user_given_linegrid);
	if(multiple==1){
		current.line_to_grid(solution_linegrid);
		int count=0;
		for(int m=0;m<9;m++){
		for(int n=0;n<9;n++){
			if(!(given_flag[m][n]==1 || user_given_linegrid[count]==solution_linegrid[count])){
				char bitmap_name[10];
				sprintf(bitmap_name,"w%d.xpm",current.grid[m][n]);
				Cell.Load(bitmap_name); Cell.SetPosition(Position(2.0+m,2.0+n)); Cell.Draw();
			}
			count++;
			render_gridlines();
		}
		}
	}
	else if(multiple<500 && multiple>0){
		// GUI ALERT
		cout<<multiple<<" solutions found, hence grid supplied is invalid!"<<endl;
		// GUI ALERT
	}
	else if(multiple==500){
		// GUI ALERT
		cout<<"At least 500 solutions possible, hence grid supplied is invalid!"<<endl;
		// GUI ALERT
	}
	else if(multiple>500){
		// GUI ALERT
		cout<<"At least ?"<<multiple<<"? solutions possible, hence grid supplied is invalid! (This stage should NOT be reached at all) :{"<<endl;
		// GUI ALERT
	}
	else{
		// GUI ALERT
		cout<<"Current grid (tried to be solved) has no possible solution or is blank!"<<endl;
		// GUI ALERT
	}
}
int check(){
	MainAppWindow.StopTimer();
	MainAppWindow.SetTimerCallback(timer);
	MainAppWindow.StartTimer(1000);
	try_to_solve(new_question_linegrid);
	if(multiple==1){
		sudoku cross_check;
		cross_check.line_to_grid(solution_linegrid);
		check_fn_flag=1;
		for(int m=0;m<9;m++){
		for(int n=0;n<9;n++){
			if(current.grid[m][n]!=0 && given_flag[m][n]==0){
				if(current.grid[m][n]==cross_check.grid[m][n]){
					char bitmap_name[10];
					sprintf(bitmap_name,"g%d.xpm",current.grid[m][n]);
					Cell.Load(bitmap_name); Cell.SetPosition(Position(2.0+m,2.0+n)); Cell.Draw();
				}
				else{
					char bitmap_name[10];
					sprintf(bitmap_name,"r%d.xpm",current.grid[m][n]);
					Cell.Load(bitmap_name); Cell.SetPosition(Position(2.0+m,2.0+n)); Cell.Draw();
				}
				render_gridlines();
			}
		}
		}
	}
	else if(multiple<500 && multiple>0){
		// GUI ALERT
		cout<<multiple<<" solutions found, hence grid supplied is invalid!"<<endl;
		// GUI ALERT
	}
	else if(multiple==500){
		// GUI ALERT
		cout<<"At least 500 solutions possible, hence grid supplied is invalid!"<<endl;
		// GUI ALERT
	}
	else if(multiple>500){
		// GUI ALERT
		cout<<"At least ?"<<multiple<<"? solutions possible, hence grid supplied is invalid! (This stage should NOT be reached at all) :{"<<endl;
		// GUI ALERT
	}
	else{
		// GUI ALERT
		cout<<"Question grid not given!"<<endl;
		// GUI ALERT
	}
}
void load_inactive_tabbed_bar(){
	Cell.Load("tabbed_main_buttons_inactive.xpm");
	Cell.SetPosition(Position(1.25,0.56));
	Cell.Draw();
}
int complete_event_1(){
	MainAppWindow.StopTimer();
	MainAppWindow.SetTimerCallback(settings);
	MainAppWindow.StartTimer(1);
	load_inactive_tabbed_bar();
}
int complete_event_2(){
	MainAppWindow.StopTimer();
	MainAppWindow.SetTimerCallback(execute_generate_algorithm);
	MainAppWindow.StartTimer(1);
	load_inactive_tabbed_bar();
}
int complete_event_3(){
	MainAppWindow.StopTimer();
	MainAppWindow.SetTimerCallback(clear_puzzle_or_cell);
	MainAppWindow.StartTimer(1);
	load_inactive_tabbed_bar();
}
int complete_event_4(){
	MainAppWindow.StopTimer();
	MainAppWindow.SetTimerCallback(execute_solve_algorithm);
	MainAppWindow.StartTimer(1);
	load_inactive_tabbed_bar();
}
int complete_event_5(){
	MainAppWindow.StopTimer();
	MainAppWindow.SetTimerCallback(check);
	MainAppWindow.StartTimer(1);
	load_inactive_tabbed_bar();
}
void activate_button(int which_button){
	char xpm_file[50];
	float x_posn;
	switch(which_button){
		case 1:
			x_posn=1.25;
			sprintf(xpm_file,"settings.xpm");
			break;
		case 2:
			x_posn=3.3;
			sprintf(xpm_file,"generate.xpm");
			break;
		case 3:
			x_posn=5.4;
			sprintf(xpm_file,"clear.xpm");
			break;
		case 4:
			x_posn=7.5;
			sprintf(xpm_file,"solve.xpm");
			break;
		case 5:
			x_posn=9.6;
			sprintf(xpm_file,"check.xpm");
			break;
	}
	Cell.Load(xpm_file);
	Cell.SetPosition(Position(x_posn,0.56));
	Cell.Draw();
	switch(which_button){
		case 1:
			MainAppWindow.SetTimerCallback(complete_event_1); // This is similar to mouseclickcallback
			break;
		case 2:
			MainAppWindow.SetTimerCallback(complete_event_2); // This is similar to mouseclickcallback
			break;
		case 3:
			MainAppWindow.SetTimerCallback(complete_event_3); // This is similar to mouseclickcallback
			break;
		case 4:
			MainAppWindow.SetTimerCallback(complete_event_4); // This is similar to mouseclickcallback
			break;
		case 5:
			MainAppWindow.SetTimerCallback(complete_event_5); // This is similar to mouseclickcallback
			break;
	}
	MainAppWindow.StartTimer(150); // Now generate_timer_event is invoked for every 100 millisecond
	
}
int wmouseclick(const Position &p){
	float x = p.GetXDistance();
	float y = p.GetYDistance();
	int temp_x = stepfn(x);
	int temp_y = stepfn(y);
	if((x>1.2 && x<3.3) && ((temp_y==0)||(temp_y==1))){
		activate_button(1);
	}
	else if((x>3.3 && x<5.4) && ((temp_y==0)||(temp_y==1))){
		activate_button(2);
	}
	else if((x>7.5 && x<9.6) && ((temp_y==0)||(temp_y==1))){
		activate_button(4);
	}
	if(check_fn_flag==1){
		for(int m=0;m<9;m++){
		for(int n=0;n<9;n++){
			if(current.grid[m][n]!=0 && given_flag[m][n]!=1){
				char bitmap_name[10];
				sprintf(bitmap_name,"w%d.xpm",current.grid[m][n]);
				Cell.Load(bitmap_name); Cell.SetPosition(Position(2.0+m,2.0+n)); Cell.Draw();
			}
			render_gridlines();
		}
		}
		check_fn_flag=0;	
	}
	else if((x>9.6 && x<11.7) && ((temp_y==0)||(temp_y==1))){
		activate_button(5);
	}
	if((x>5.4 && x<7.5) && ((temp_y==0)||(temp_y==1))){
		activate_button(3);
	}
	else{		
		if(((temp_x>=2)&&(temp_x<=11))&&((temp_y>=2)&&(temp_y<=11))){ // This is to store the selected cell in grid
			for(int i=0;i<9;i++){
			for(int j=0;j<9;j++){
				if((temp_x==2+i)&&(temp_y==2+j)){
					cellselection[i][j]=1;
					if(current.grid[i][j]==0){
						Cell.Load("sblank.xpm"); Cell.SetPosition(Position(2.0+i,2.0+j)); Cell.Draw();
					}
					else{
						char bitmap_name[10];
						sprintf(bitmap_name,"s%d.xpm",current.grid[i][j]);
						Cell.Load(bitmap_name); Cell.SetPosition(Position(2.0+i,2.0+j)); Cell.Draw();
					}
					render_gridlines();
				}
				else{
					if(cellselection[i][j]==1){
						if(current.grid[i][j]==0){
							Cell.Load("wblank.xpm"); Cell.SetPosition(Position(2.0+i,2.0+j)); Cell.Draw();
						}
						else{
							char bitmap_name[10];
							if(given_flag[i][j]==1){
							sprintf(bitmap_name,"grey%d.xpm",current.grid[i][j]);
							}
							else{
							sprintf(bitmap_name,"w%d.xpm",current.grid[i][j]);
							}
							Cell.Load(bitmap_name); Cell.SetPosition(Position(2.0+i,2.0+j)); Cell.Draw();
						}
						render_gridlines();
						cellselection[i][j]=0;
					}
				}
			}
			}
		}
		if(temp_y==12){	
			for(int i=0;i<9;i++){ // This is to store which number is selected
				if(temp_x==2+i){
					numberselection[i]=1;
				}
				else{
					numberselection[i]=0;
				}
			}
			for (int k=0;k<9;k++){
				if(numberselection[k]==1){
					for (int i=0;i<9;i++){
					for (int j=0;j<9;j++){
						if(cellselection[i][j]==1 && given_flag[i][j]==0){
							char bitmap_name[10];
							sprintf(bitmap_name,"s%d.xpm",(k+1));	
							Cell.Load(bitmap_name); Cell.SetPosition(Position(2.0+i,2.0+j)); Cell.Draw();
							current.grid[i][j]=k+1;
							current.decorated_sudoku(); // debugging
							render_gridlines();
						}
					}
					}
				}
			}
		}
	}
}
void window_grid_start(){ // a 9x9 grid is generated and numbers are shown which are to be clicked for choosing
	is_puzzle_symmetric=1;
	float gridx=2.0,gridy=2.0; // here (gridx,gridy) is the left togridx corner of the grid  
	MainAppWindow.Open(); assert( MainAppWindow.GetStatus() == WindowOpen );
	for(int i=0;i<9;i++){	
		numberselection[i]=0;
		for(int j=0;j<9;j++){
			cellselection[i][j]=0;
		}
	}
	load_inactive_tabbed_bar();
	for(int i=1;i<10;i++){ // The following steps are for printing numbers
		char bitmap_name[10];
		sprintf(bitmap_name,"k%d.xpm",i);
		Cell.Load(bitmap_name);
		Cell.SetPosition(Position(1.0+i,12.0));
		Cell.Draw();
	}
	MainAppWindow.SetMouseClickCallback(wmouseclick);
	for (int i=0;i<9;i++){
	for (int j=0;j<9;j++){
		if(current.grid[i][j]==0){
			Cell.Load("wblank.xpm"); Cell.SetPosition(Position(2.0+i,2.0+j)); Cell.Draw();
			given_flag[i][j]=0;
		}
		else{
			char bitmap_name[10];
			sprintf(bitmap_name,"grey%d.xpm",current.grid[i][j]);
			given_flag[i][j]=1;
			Cell.Load(bitmap_name); Cell.SetPosition(Position(2.0+i,2.0+j)); Cell.Draw();
		}
		render_gridlines();
	}
	}
}
int ApiMain(){
	current.init_current_obj();
	window_grid_start();
	return (0);
}
