#include<iostream>
#include<cstdio>
#include<cstdlib>
#include<cstring>
#include<ctime>
#include<ezwin.h>
#include"rect.h"
#include"bitmap.h"
#include"randint.h"
using namespace std;

SimpleWindow MainAppWindow("Sudoku Solver and Generator",13.0,14.0,Position(1.0,1.0));
SimpleWindow SettingsWindow("Tweak App and Handle Files",10.0,10.0,Position(4.0,4.0));
SimpleWindow MessageWindow("Alert!",8.0,2.5,Position(3.5,6.6));
SimpleWindow ChoiceWindow("Choices for You!",8.0,2.5,Position(3.5,6.6));
BitMap Cell(MainAppWindow),Image(SettingsWindow),Image1(SettingsWindow),Image2(SettingsWindow),Image3(SettingsWindow),Ok(MessageWindow),Choice(ChoiceWindow);

void alert(char line1[500],char line2[500],char line3[500]){
	MessageWindow.Open();
	MessageWindow.RenderText(Position(2.2,-0.5),Position(6.0,1.5),line1);
	MessageWindow.RenderText(Position(2.2,0.0),Position(6.0,2.0),line2);
	MessageWindow.RenderText(Position(2.2,0.5),Position(6.0,2.5),line3);
}
int choicemouseclick(const Position &s){
	float x2 = s.GetXDistance();
	float y2 = s.GetYDistance();
	char yes_no_choice;
//	cout <<x2<<" "<<y2<<endl;
	if ((y2>1.48) && (y2<2.15)){
		if(x2>1.48 && x2>2.68){
		yes_no_choice='n';
		ChoiceWindow.Close();
		int choicecount=1;
		}
		if(x2>5.46 && x2>6.66){
		yes_no_choice='y';
		ChoiceWindow.Close();
		int choicecount=1;
		}
	}
}
char yes_no(char line1[500],char line2[500]){
	char yes_no_choice='y';
	int choicecount=0;
	ChoiceWindow.Open();
	ChoiceWindow.RenderText(Position(2.2,-0.5),Position(6.0,1.5),line1);
	ChoiceWindow.RenderText(Position(2.2,0.0),Position(6.0,2.0),line2);
	Choice.Load("yes_choice.xpm");Choice.SetPosition(Position(5.5,1.5));Choice.Draw();
	Choice.Load("no_choice.xpm");Choice.SetPosition(Position(1.5,1.5));Choice.Draw();
	ChoiceWindow.SetMouseClickCallback(choicemouseclick);
	return yes_no_choice;
}
#include"sudokulib.h"
sudoku current;
int cellselection[9][9]; // This is used to ensure which cell is selected
int numberselection[9]; // This is used to ensure which number is selected
int given_flag[9][9],check_fn_flag=0;
int totalpuzzle_time_in_seconds=0;
int has_generator_been_used=0;
int yes_no_choice=0,time_seconds=0,time_minutes=0,time_hours=0;
int timer(){
	if(has_generator_been_used){
	time_seconds=totalpuzzle_time_in_seconds%60;
	time_minutes=totalpuzzle_time_in_seconds/60;
	time_hours=totalpuzzle_time_in_seconds/3600;
	char mystring[20];
	if(time_seconds<10 && time_minutes<10){
		sprintf(mystring,"0%d:0%d:0%d",time_hours,time_minutes,time_seconds);
	}
	else if(time_seconds>=10 && time_minutes>=10){
		sprintf(mystring,"0%d:%d:%d",time_hours,time_minutes,time_seconds);
	}
	else if(time_seconds>=10 && time_minutes<10){
		sprintf(mystring,"0%d:0%d:%d",time_hours,time_minutes,time_seconds);
	}
	else{
		sprintf(mystring,"0%d:%d:0%d",time_hours,time_minutes,time_seconds);
	}
	MainAppWindow.RenderRectangle(Position(4.0,13.0),Position(9.0,14.0),White,false);
	MainAppWindow.RenderText(Position(4.0,13.0),Position(9.0,14.0), mystring);
	totalpuzzle_time_in_seconds++;
	}
}
void save_grid(){
	char to_be_saved_linegrid[82];
	int ifilename=time(NULL);
	char sfilename[15]; // 12345678.sdk'\0' = 15 characters
	sprintf(sfilename,"%d.sdk",ifilename);
	FILE *time_sdk;
	time_sdk=fopen(sfilename,"w");
	if(time_sdk==NULL){
		char alert_window_text1[500],alert_window_text2[500]=" ",alert_window_text3[500]=" ";
		sprintf(alert_window_text1,"Failed to create the file %d.sdk",ifilename);
		alert(alert_window_text1,alert_window_text2,alert_window_text3);
		return;
	}
	current.grid_to_line(current.grid,to_be_saved_linegrid);
	fputs(to_be_saved_linegrid,time_sdk);
	fclose(time_sdk);
	char alert_window_text1[500],alert_window_text2[500]=" ",alert_window_text3[500]=" ";
	sprintf(alert_window_text1,"Saved in %d.sdk",ifilename);
	alert(alert_window_text1,alert_window_text2,alert_window_text3);
	return;
}
float stepfn(float a){ // This is greatest integral function which is used in next steps
	int temp;
	temp=a;
	return temp;
}
int settingsmouseclick(const Position &r){
	float x1 = r.GetXDistance();
	float y1 = r.GetYDistance();
	int temp_x1 = stepfn(x1);
	int temp_y1 = stepfn(y1);
	if(temp_y1==0){
		if(x1<=1.3){
		SettingsWindow.Close();
		}
		else if(x1>=8.7){
		SettingsWindow.Close();
		MainAppWindow.Close();
		}
	}
	if(y1>2&&y1<2.93){
		Image1.Load("tick.xpm");Image1.Erase();Image1.SetPosition(Position(5.5,2.25));Image1.Draw();
		difflevel=1;
	}
	else if(y1>2.93&&y1<3.85){
		Image1.Load("tick.xpm");Image1.Erase();Image1.SetPosition(Position(5.5,3.22));Image1.Draw();
		difflevel=2;
	}
	else if(y1>3.85&&y1<4.78){
		Image1.Load("tick.xpm");Image1.Erase();Image1.SetPosition(Position(5.5,4.19));Image1.Draw();
		difflevel=3;
	}
	else if(y1>4.78&&y1<5.70){
		Image1.Load("tick.xpm");Image1.Erase();Image1.SetPosition(Position(5.5,5.16));Image1.Draw();
		difflevel=4;
	}
	if (x1>0.68&&x1<9.30){
		if(y1>7.87 && y1<8.78){
			if(is_puzzle_symmetric==0){
				is_puzzle_symmetric=1;
				Image2.Load("no.xpm");Image2.SetPosition(Position(6.75,8.00)); Image2.Draw();
			}
			else{
				is_puzzle_symmetric=0;
				Image2.Load("yes.xpm");Image2.SetPosition(Position(6.75,8.00)); Image2.Draw();
			}
		}
	 	else if(y1>6.07 && y1<6.96){
			if(no_guessing_reqd==1){
				no_guessing_reqd=0;
				Image3.Load("yes.xpm");Image3.SetPosition(Position(6.75,6.20)); Image3.Draw();
			}
			else{
				no_guessing_reqd=1;
				Image3.Load("no.xpm");Image3.SetPosition(Position(6.75,6.20)); Image3.Draw();
			}
		}
	}
}
int settings(){
	MainAppWindow.StopTimer();
	MainAppWindow.SetTimerCallback(timer);
	MainAppWindow.StartTimer(1000);
	SettingsWindow.Open();
	SettingsWindow.SetMouseClickCallback(settingsmouseclick);
	Image.Load("settingswindow.xpm");Image.SetPosition(Position(0.0,0.0)); Image.Draw();
	if( difflevel==1 ){
		Image1.Load("tick.xpm");Image1.Erase();Image1.SetPosition(Position(5.5,2.25));Image1.Draw();
	}
	else if( difflevel==2 ){
		Image1.Load("tick.xpm");Image1.Erase();Image1.SetPosition(Position(5.5,3.22));Image1.Draw();
	}
	else if( difflevel==3 ){
		Image1.Load("tick.xpm");Image1.Erase();Image1.SetPosition(Position(5.5,4.19));Image1.Draw();
	}
	else if( difflevel==4 ){
		Image1.Load("tick.xpm");Image1.Erase();Image1.SetPosition(Position(5.5,5.16));Image1.Draw();
	}
	if(is_puzzle_symmetric==1){
		Image2.Load("no.xpm");Image2.SetPosition(Position(6.75,8.00)); Image2.Draw();
	}
	else if(is_puzzle_symmetric==0){
		Image2.Load("yes.xpm") ;Image2.SetPosition(Position(6.75,8.00)); Image2.Draw();
	}
	if(no_guessing_reqd==0){
		Image3.Load("yes.xpm");Image3.SetPosition(Position(6.75,6.20)); Image3.Draw();
	}
	else if(no_guessing_reqd==1){
		Image3.Load("no.xpm") ;Image3.SetPosition(Position(6.75,6.20)); Image3.Draw();
	}
}
void render_gridlines(){
	float gridx=2.0,gridy=2.0; // here (gridx,gridy) is the left to grid x corner of the grid
	for(int i=0;i<=9;i++){
		if((i)%3==0){
			MainAppWindow.RenderLine  (Position(gridx+i,gridy), Position(gridx+i,gridy+9),Black, 0.1);
			MainAppWindow.RenderLine  (Position(gridx,gridy+i), Position(gridx+9,gridy+i),Black, 0.1);
		}
		else{
			MainAppWindow.RenderLine  (Position(gridx+i,gridy), Position(gridx+i,gridy+9),Black, 0.0);
			MainAppWindow.RenderLine  (Position(gridx,gridy+i), Position(gridx+9,gridy+i),Black, 0.0);
		}
	}
}
int clear_puzzle_or_cell(){
	MainAppWindow.StopTimer();
	MainAppWindow.SetTimerCallback(timer);
	MainAppWindow.StartTimer(1000);
	int single_clear_flag=0;
	for(int i=0;i<9;i++){
	for(int j=0;j<9;j++){
		if(cellselection[i][j]==1){
			if(given_flag[i][j]!=1){
				current.grid[i][j]=0;
				current.np[i][j]=9;
				for(int k=0;k<9;k++){
					current.posbl[i][j][k]=k+1;
				}
				Cell.Load("sblank.xpm"); Cell.SetPosition(Position(2.0+i,2.0+j)); Cell.Draw();
				render_gridlines();
				given_flag[i][j]=0;
			}
			single_clear_flag=1;
		}
	}
	}
	if(single_clear_flag==0){
		char alert_window_text1[500]="Are you sure you want to ",alert_window_text2[500]="clear the current grid? (y/n)",confirm='n';
		confirm=yes_no(alert_window_text1,alert_window_text2);
		if(confirm=='y'){
			MainAppWindow.StopTimer();
			current.init_current_obj();
			for(int m=0;m<9;m++){
			for(int n=0;n<9;n++){
				Cell.Load("wblank.xpm"); Cell.SetPosition(Position(2.0+m,2.0+n)); Cell.Draw();
				render_gridlines();
				given_flag[m][n]=0;
			}
			}
		}
	}
}
int generatehint(){
	int hint_text_printed=0;
	sudoku cross_check;
	cross_check.line_to_grid(solution_linegrid);
	for(int m=0;m<9;m++){
		for(int n=0;n<9;n++){
			if(current.grid[m][n]==0 && cross_check.grid[m][n]!=0){
				char alert_window_text1[500],alert_window_text2[500]="at cell with co-ordinates",alert_window_text3[500];
				sprintf(alert_window_text1,"You can plug in %d",cross_check.grid[m][n]);
				sprintf(alert_window_text3,"Row %d, Column %d!",n+1,m+1);
				alert(alert_window_text1,alert_window_text2,alert_window_text3);
				hint_text_printed=1;
				break;
			}
		}
		if(hint_text_printed==1){
			break;
		}
	}
	if(hint_text_printed!=1){
		char alert_window_text1[500]="Sorry, no hint could be",alert_window_text2[500]="automatically generated :{",alert_window_text3[500]="Try solving entire grid!";
		alert(alert_window_text1,alert_window_text2,alert_window_text3);
	}
}
int execute_generate_algorithm(){
	has_generator_been_used=1;
	totalpuzzle_time_in_seconds=0;
	MainAppWindow.StopTimer();
	MainAppWindow.SetTimerCallback(timer);
	MainAppWindow.StartTimer(1000);
	current.init_current_obj();
	generate();
	current.line_to_grid(new_question_linegrid);
	for(int m=0;m<9;m++){
	for(int n=0;n<9;n++){
		if(current.grid[m][n]==0){
			Cell.Load("wblank.xpm"); Cell.SetPosition(Position(2.0+m,2.0+n)); Cell.Draw();
			given_flag[m][n]=0;
		}
		else{
			char bitmap_name[10];
			sprintf(bitmap_name,"grey%d.xpm",current.grid[m][n]);
			given_flag[m][n]=1;
			Cell.Load(bitmap_name); Cell.SetPosition(Position(2.0+m,2.0+n)); Cell.Draw();
		}
		render_gridlines();
	}
	}
}
int execute_solve_algorithm(){
	MainAppWindow.StopTimer();
	MainAppWindow.SetTimerCallback(timer);
	MainAppWindow.StartTimer(1000);
	solve_button=1;
	current.grid_to_line(current.grid,user_given_linegrid);
	try_to_solve(user_given_linegrid);
	if(multiple==1 && strcmp(user_given_linegrid,solution_linegrid)!=0){
		char hint_choice;
		cout<<"Want just a hint? (y/n) ";
		cin>>hint_choice;
		if(hint_choice!='n'){
			generatehint();
		}
		else{
			MainAppWindow.StopTimer();
			current.line_to_grid(solution_linegrid);
			int count=0;
			for(int m=0;m<9;m++){
			for(int n=0;n<9;n++){
				if(!(given_flag[m][n]==1 || user_given_linegrid[count]==solution_linegrid[count])){
					char bitmap_name[10];
					sprintf(bitmap_name,"w%d.xpm",current.grid[m][n]);
					Cell.Load(bitmap_name); Cell.SetPosition(Position(2.0+m,2.0+n)); Cell.Draw();
				}
				count++;
				render_gridlines();
			}
			}
			cout<<recursions<<endl;
		}
	}
	else if(multiple>1 && multiple<500){
		char alert_window_text1[500],alert_window_text2[500]="grid supplied is invalid!",alert_window_text3[500]=" ";
		sprintf(alert_window_text1,"%d solutions found, hence",multiple);
		alert(alert_window_text1,alert_window_text2,alert_window_text3);
	}
	else if(multiple==500){
		char alert_window_text1[500]="At least 500 solutions exist,",alert_window_text2[500]="hence grid supplied is invalid!",alert_window_text3[500]=" ";
		alert(alert_window_text1,alert_window_text2,alert_window_text3);
	}
	else if(multiple>500){
		cout<<"At least ?"<<multiple<<"? solutions possible, hence grid supplied is invalid! (This stage should NOT be reached at all) :{"<<endl;
	}
	else if(multiple!=1){
		char alert_window_text1[500]="Tried solving the grid",alert_window_text2[500]="but it has no possible",alert_window_text3[500]="solution or is blank!";
		alert(alert_window_text1,alert_window_text2,alert_window_text3);
	}
	solve_button=0;
}
int check(){
	MainAppWindow.StopTimer();
	MainAppWindow.SetTimerCallback(timer);
	if(check_fn_flag!=1){
		try_to_solve(new_question_linegrid);
		if(multiple==1){
			char cross_check_line[82];
			current.grid_to_line(current.grid,cross_check_line);
			if(strcmp(cross_check_line,solution_linegrid)!=0){
				MainAppWindow.StartTimer(1000);
			}
			sudoku cross_check;
			cross_check.line_to_grid(solution_linegrid);
			check_fn_flag=1;
			for(int m=0;m<9;m++){
			for(int n=0;n<9;n++){
				if(current.grid[m][n]!=0 && given_flag[m][n]==0){
					if(current.grid[m][n]==cross_check.grid[m][n]){
						char bitmap_name[10];
						sprintf(bitmap_name,"g%d.xpm",current.grid[m][n]);
						Cell.Load(bitmap_name); Cell.SetPosition(Position(2.0+m,2.0+n)); Cell.Draw();
					}
					else{
						char bitmap_name[10];
						sprintf(bitmap_name,"r%d.xpm",current.grid[m][n]);
						Cell.Load(bitmap_name); Cell.SetPosition(Position(2.0+m,2.0+n)); Cell.Draw();
					}
					render_gridlines();
				}
			}
			}
		}
		else if(multiple<500 && multiple>0){
			char alert_window_text1[500],alert_window_text2[500]="grid supplied is invalid!",alert_window_text3[500]=" ";
			sprintf(alert_window_text1,"%d solutions found, hence",multiple);
			alert(alert_window_text1,alert_window_text2,alert_window_text3);
		}
		else if(multiple==500){
			char alert_window_text1[500]="At least 500 solutions exist,",alert_window_text2[500]="hence grid supplied is invalid!",alert_window_text3[500]=" ";
			alert(alert_window_text1,alert_window_text2,alert_window_text3);
		}
		else if(multiple>500){
			cout<<"At least ?"<<multiple<<"? solutions possible, hence grid supplied is invalid! (This stage should NOT be reached at all) :{"<<endl;
		}
		else{
			char alert_window_text1[500]="Tried solving the grid",alert_window_text2[500]="but it has no possible",alert_window_text3[500]="solution or is blank!";
			alert(alert_window_text1,alert_window_text2,alert_window_text3);
		}
	}
}
void load_inactive_tabbed_bar(){
	Cell.Load("tabbed_main_buttons_inactive.xpm");
	Cell.SetPosition(Position(1.25,0.56));
	Cell.Draw();
}
int complete_event_1(){
	MainAppWindow.StopTimer();
	MainAppWindow.SetTimerCallback(settings);
	MainAppWindow.StartTimer(30);
	load_inactive_tabbed_bar();
}
int complete_event_2(){
	MainAppWindow.StopTimer();
	MainAppWindow.SetTimerCallback(execute_generate_algorithm);
	MainAppWindow.StartTimer(30);
	load_inactive_tabbed_bar();
}
int complete_event_3(){
	MainAppWindow.StopTimer();
	MainAppWindow.SetTimerCallback(clear_puzzle_or_cell);
	MainAppWindow.StartTimer(30);
	load_inactive_tabbed_bar();
}
int complete_event_4(){
	MainAppWindow.StopTimer();
	MainAppWindow.SetTimerCallback(execute_solve_algorithm);
	MainAppWindow.StartTimer(30);
	load_inactive_tabbed_bar();
}
int complete_event_5(){
	MainAppWindow.StopTimer();
	MainAppWindow.SetTimerCallback(check);
	MainAppWindow.StartTimer(30);
	load_inactive_tabbed_bar();
}
void activate_button(int which_button){
	char xpm_file[50];
	float x_posn;
	switch(which_button){
		case 1:
			x_posn=1.25;
			sprintf(xpm_file,"settings.xpm");
			break;
		case 2:
			x_posn=3.3;
			sprintf(xpm_file,"generate.xpm");
			break;
		case 3:
			x_posn=5.4;
			sprintf(xpm_file,"clear.xpm");
			break;
		case 4:
			x_posn=7.5;
			sprintf(xpm_file,"solve.xpm");
			break;
		case 5:
			x_posn=9.6;
			sprintf(xpm_file,"check.xpm");
			break;
	}
	Cell.Load(xpm_file);
	Cell.SetPosition(Position(x_posn,0.56));
	Cell.Draw();
	switch(which_button){
		case 1:
			MainAppWindow.SetTimerCallback(complete_event_1);
			break;
		case 2:
			MainAppWindow.SetTimerCallback(complete_event_2);
			break;
		case 3:
			MainAppWindow.SetTimerCallback(complete_event_3); 
			break;
		case 4:
			MainAppWindow.SetTimerCallback(complete_event_4); 
			break;
		case 5:
			MainAppWindow.SetTimerCallback(complete_event_5); 
			break;
	}
	MainAppWindow.StartTimer(50);
}
int wmouseclick(const Position &p){
	float x = p.GetXDistance();
	float y = p.GetYDistance();
	int temp_x = stepfn(x);
	int temp_y = stepfn(y);
	if((x>1.2 && x<3.3) && ((temp_y==0)||(temp_y==1))){
		activate_button(1);
	}
	else if((x>3.3 && x<5.4) && ((temp_y==0)||(temp_y==1))){
		activate_button(2);
	}
	else if((x>7.5 && x<9.6) && ((temp_y==0)||(temp_y==1))){
		activate_button(4);
	}
	if((x>9.6 && x<11.7) && ((temp_y==0)||(temp_y==1))){
		activate_button(5);
	}
	else if(check_fn_flag==1 && !((x>1.2 && x<3.3) && ((temp_y==0)||(temp_y==1))) && !((x>5.4 && x<7.5) && ((temp_y==0)||(temp_y==1)))){
		for(int m=0;m<9;m++){
		for(int n=0;n<9;n++){
			if(current.grid[m][n]!=0 && given_flag[m][n]!=1){
				char bitmap_name[10];
				sprintf(bitmap_name,"w%d.xpm",current.grid[m][n]);
				Cell.Load(bitmap_name); Cell.SetPosition(Position(2.0+m,2.0+n)); Cell.Draw();
			}
			render_gridlines();
		}
		}
		check_fn_flag=0;	
	}	
	if((x>5.4 && x<7.5) && ((temp_y==0)||(temp_y==1))){
		activate_button(3);
	}
	else{		
		if(((temp_x>=2)&&(temp_x<=11))&&((temp_y>=2)&&y<11.5)){ // This is to store the selected cell in grid
			for(int i=0;i<9;i++){
			for(int j=0;j<9;j++){
				if((temp_x==2+i)&&(temp_y==2+j)){
					cellselection[i][j]=1;
					if(current.grid[i][j]==0){
						Cell.Load("sblank.xpm"); Cell.SetPosition(Position(2.0+i,2.0+j)); Cell.Draw();
					}
					else{
						char bitmap_name[10];
						sprintf(bitmap_name,"s%d.xpm",current.grid[i][j]);
						Cell.Load(bitmap_name); Cell.SetPosition(Position(2.0+i,2.0+j)); Cell.Draw();
					}
					render_gridlines();
				}
				else{
					if(cellselection[i][j]==1){
						if(current.grid[i][j]==0){
							Cell.Load("wblank.xpm"); Cell.SetPosition(Position(2.0+i,2.0+j)); Cell.Draw();
						}
						else{
							char bitmap_name[10];
							if(given_flag[i][j]==1){
							sprintf(bitmap_name,"grey%d.xpm",current.grid[i][j]);
							}
							else{
							sprintf(bitmap_name,"w%d.xpm",current.grid[i][j]);
							}
							Cell.Load(bitmap_name); Cell.SetPosition(Position(2.0+i,2.0+j)); Cell.Draw();
						}
						render_gridlines();
						cellselection[i][j]=0;
					}
				}
			}
			}
		}
		if(y>11.5 && y<12.5){	
			for(int i=0;i<9;i++){ // This is to store which number is selected
				if(temp_x==2+i){
					numberselection[i]=1;
				}
				else{
					numberselection[i]=0;
				}
			}
			for (int k=0;k<9;k++){
				if(numberselection[k]==1){
					for (int i=0;i<9;i++){
					for (int j=0;j<9;j++){
						if(cellselection[i][j]==1 && given_flag[i][j]==0){
							char bitmap_name[10];
							sprintf(bitmap_name,"s%d.xpm",(k+1));	
							Cell.Load(bitmap_name); Cell.SetPosition(Position(2.0+i,2.0+j)); Cell.Draw();
							current.grid[i][j]=k+1;
							current.decorated_sudoku(); // debugging
							render_gridlines();
						}
					}
					}
				}
			}
		}
	}
}
void window_grid_start(){ // a 9x9 grid is generated and numbers are shown which are to be clicked for choosing
	float gridx=2.0,gridy=2.0; // here (gridx,gridy) is the left togridx corner of the grid  
	MainAppWindow.Open();
	if(!(MainAppWindow.GetStatus()==WindowOpen)){
		cout<<"Error Opening Window :("<<endl;
	}
	for(int i=0;i<9;i++){	
		numberselection[i]=0;
		for(int j=0;j<9;j++){
			cellselection[i][j]=0;
		}
	}
	load_inactive_tabbed_bar();
	for(int i=1;i<10;i++){ // The following steps are for printing numbers
		char bitmap_name[10];
		sprintf(bitmap_name,"k%d.xpm",i);
		Cell.Load(bitmap_name);
		Cell.SetPosition(Position(1.0+i,11.5));
		Cell.Draw();
	}
	MainAppWindow.SetMouseClickCallback(wmouseclick);
	for (int i=0;i<9;i++){
	for (int j=0;j<9;j++){
		if(current.grid[i][j]==0){
			Cell.Load("wblank.xpm"); Cell.SetPosition(Position(2.0+i,2.0+j)); Cell.Draw();
			given_flag[i][j]=0;
		}
		else{
			char bitmap_name[10];
			sprintf(bitmap_name,"grey%d.xpm",current.grid[i][j]);
			given_flag[i][j]=1;
			Cell.Load(bitmap_name); Cell.SetPosition(Position(2.0+i,2.0+j)); Cell.Draw();
		}
		render_gridlines();
	}
	}
}
int ApiMain(){
	current.init_current_obj();
	window_grid_start();
	return (0);
}
